#ifndef _CALIB_PRIVATE_H
#define _CALIB_PRIVATE_H
#include "Std_Types.h"
#include "calib_public.h"
#include "calib_callout.h"

enum CalibStatus
{
    Calib_RequestBit = 1,
    Calib_FinishedBit = 2,
};

#define Calib_Data_Sign                 0x55
#define Calib_Buffer_size               5
#define Calib_Data_Size                 8
typedef union
{
    uint8_t byte[Calib_Data_Size];
    struct 
    {
        uint8_t sign;
        uint16_t value;
        uint8_t reserved0;
        uint8_t reserved1;
        uint16_t reserved2;
        uint8_t reserved3;
    }def;
}Data_Un;

typedef struct 
{
    uint8_t status;
    uint16_t addr;
    Data_Un data;
    uint16_t buffer[Calib_Buffer_size];
    uint8_t index;
}CalibData_St;

CalibData_St CalibDataCtl[total_data];


uint16_t Calib_FilterData(uint16_t * data);

#endif