/**************   FICOSA COMMAND AND CONTROL SYSTEMS DIVISION  ****************
| File:           |  Crc.h
| Init Date:      |  
| Rev. Date.:     |  
|-----------------|------------------------------------------------------------
| Language:       |  MISRA C
| Spec. Document: |  
|-----------------|------------------------------------------------------------
| Project:        |  ARCGEN BSW
| Reference:      |  
| Version:        |  -
|------------------------------------------------------------------------------
|   Date  - Cod. -  Description
|
|  17/07/14   ATo    Document Creation
|------------------------------------------------------------------------------
| DESCRIPTION:
|  CRC Service following Autosar 3.2 defined in:
| http://www.autosar.org/fileadmin/files/releases/3-2/software-architecture/system-services/standard/AUTOSAR_SWS_CRC_Routines.pdf
**************************   FI DE LA CAPCALERA  *****************************/
#ifndef _FICOCOMCRC_H
#define _FICOCOMCRC_H

/* -------------------------------- Includes -------------------------------- */
#include "Std_Types.h"
#include "Global.h"

/* -------------------------------- Defines --------------------------------- */

/* ------------------------------- Data Types ------------------------------- */

/* ---------------------------- Global Variables ---------------------------- */

/* ------------------------------- Prototypes ------------------------------ */
/*****************************************************************************
| Portability: Generic
|----------------------------------------------------------------------------
| Operations: This service makes a CRC for Melexis SPI. 
|---------------------------------------------------------------------------
| Arguments:
| Message: Pointer to start address of data block to be calculated. 

|---------------------------------------------------------------------------
| Return: 32 bit result of CRC calculation.
|---------------------------------------------------------------------------
| Timing:
| Tmax: ? cpu cycles | O(n): CTE 
/---------------------------------------------------------------------------*/
UI_8 cba_256_calc_crc(UI_8 *message);

/*** Routines for SSU ***/
UI_16 CalcByteCrc(UI_16 crc, UI_8 new_byte);
UI_16 CalcCompleteCrc(UI_8 * buffer, UI_16 len);

#endif /* _FICOCOMCRC_H */
