/*********************************************************************************************************************
 * Copyright (c) 2021, Infineon Technologies AG
 *
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * 
 * 
 * Boost Software License - Version 1.0 - August 17th, 2003
 * 
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 * 
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * 
 *********************************************************************************************************************/


/********************************************************************************************************
 * @file        TLE926x_SPI.c
 *
 * @brief       Implementation of all SPI related functions
 *
 * @version     V1.0.0
 * @date        
 * @author      Fedy Farhat
 * @author      Michael Schaffarczyk
 ********************************************************************************************************/



/* ================================================================================ */
/* ============================   HEADER FILES     ================================ */
/* ================================================================================ */ 

#include "TLE926x_SPI.h"
#include "..\config\mcal\peripheral\sercom\spi_master\plib_sercom0_spi_master.h"
#include "..\config\mcal\peripheral\port\plib_port.h"



uint16_t TLE9263_Tx_Buff_u16;
uint16_t TLE9263_Rx_Buff_u16;
uint32_t  TLF9263_SPI_Tx_Flag = 0;


void CALLBACK(uintptr_t context)
{
	TLF9263_SPI_Tx_Flag = 0;
}


/* ================================================================================ */
/* =======================   SPI communication functions     ====================== */
/* ================================================================================ */ 



uint8_t sbc_spi_init(void) 
{
	//SERCOM0_SPI_CallbackRegister (&CALLBACK, (uintptr_t)NULL );
    return 0;
}



uint16_t SBC_SPI_TRANSFER16(uint8_t Upper, uint8_t Lower) 
{

	bool ret;
	uint16_t temp;
	
	TLE9263_Tx_Buff_u16 = ((uint16_t)Upper);
	TLE9263_Tx_Buff_u16 |= (((uint16_t)Lower)<< 8);
	TLF9263_SPI_Tx_Flag = 0x1;
    Spi_Software_Trigger_Clear();
	ret = SERCOM0_SPI_WriteRead(&TLE9263_Tx_Buff_u16,2,&TLE9263_Rx_Buff_u16,2);

    if(ret)
    {
        while(SERCOM0_SPI_IsTransmitterBusy() == 1);
    }
	Spi_Software_Trigger_Set();
	/*
	if(ret)
	{
		for(;;){
			__enable_irq();
			if(TLF9263_SPI_Tx_Flag == 0 )
			{
				break;
			}
			__disable_irq();
		}
	}*/
	
	temp = TLE9263_Rx_Buff_u16<<8;
	TLE9263_Rx_Buff_u16 = TLE9263_Rx_Buff_u16>>8;
	TLE9263_Rx_Buff_u16 = (TLE9263_Rx_Buff_u16&0xFF) | (temp&0xFF00);
	return TLE9263_Rx_Buff_u16;
}



