/*
 * Instance header file for ATSAME51N20A
 *
 * Copyright (c) 2022 Microchip Technology Inc. and its subsidiaries.
 *
 * Subject to your compliance with these terms, you may use Microchip software and any derivatives
 * exclusively with Microchip products. It is your responsibility to comply with third party license
 * terms applicable to your use of third party software (including open source software) that may
 * accompany Microchip software.
 *
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY,
 * APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL OR CONSEQUENTIAL
 * LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF
 * MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
 * ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT
 * EXCEED THE AMOUNT OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 */

/* file generated from device description version 2022-02-14T14:27:15Z */
#ifndef _SAME51_EVSYS_INSTANCE_
#define _SAME51_EVSYS_INSTANCE_


/* ========== Instance Parameter definitions for EVSYS peripheral ========== */
#define EVSYS_ASYNCHRONOUS_CHANNELS              (0xFFFFF000) /* Mask of Only Asynchronous Channels */
#define EVSYS_CHANNELS                           (32)       /* Total Number of Channels */
#define EVSYS_CHANNELS_BITS                      (5)        /* Number of bits to select Channel */
#define EVSYS_EXTEVT_NUM                         (0)        /* Number of External Event Generators */
#define EVSYS_GCLK_ID_0                          (11)       /* Index of Generic Clock 0 */
#define EVSYS_GCLK_ID_1                          (12)       /* Index of Generic Clock 1 */
#define EVSYS_GCLK_ID_2                          (13)       /* Index of Generic Clock 2 */
#define EVSYS_GCLK_ID_3                          (14)       /* Index of Generic Clock 3 */
#define EVSYS_GCLK_ID_4                          (15)       /* Index of Generic Clock 4 */
#define EVSYS_GCLK_ID_5                          (16)       /* Index of Generic Clock 5 */
#define EVSYS_GCLK_ID_6                          (17)       /* Index of Generic Clock 6 */
#define EVSYS_GCLK_ID_7                          (18)       /* Index of Generic Clock 7 */
#define EVSYS_GCLK_ID_8                          (19)       /* Index of Generic Clock 8 */
#define EVSYS_GCLK_ID_9                          (20)       /* Index of Generic Clock 9 */
#define EVSYS_GCLK_ID_10                         (21)       /* Index of Generic Clock 10 */
#define EVSYS_GCLK_ID_11                         (22)       /* Index of Generic Clock 11 */
#define EVSYS_GENERATORS                         (119)      /* Total Number of Event Generators */
#define EVSYS_GENERATORS_BITS                    (7)        /* Number of bits to select Event Generator */
#define EVSYS_SYNCH_NUM                          (12)       /* Number of Synchronous Channels */
#define EVSYS_SYNCH_NUM_BITS                     (4)        /* Number of bits to select Synchronous Channels */
#define EVSYS_USERS                              (67)       /* Total Number of Event Users */
#define EVSYS_USERS_BITS                         (7)        /* Number of bits to select Event User */
#define EVSYS_INSTANCE_ID                        (39)       /* Instance index for EVSYS */

#endif /* _SAME51_EVSYS_INSTANCE_ */
