/*
 * Instance header file for ATSAME51N20A
 *
 * Copyright (c) 2022 Microchip Technology Inc. and its subsidiaries.
 *
 * Subject to your compliance with these terms, you may use Microchip software and any derivatives
 * exclusively with Microchip products. It is your responsibility to comply with third party license
 * terms applicable to your use of third party software (including open source software) that may
 * accompany Microchip software.
 *
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY,
 * APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL OR CONSEQUENTIAL
 * LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF
 * MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
 * ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT
 * EXCEED THE AMOUNT OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 */

/* file generated from device description version 2022-02-14T14:27:15Z */
#ifndef _SAME51_TCC1_INSTANCE_
#define _SAME51_TCC1_INSTANCE_


/* ========== Instance Parameter definitions for TCC1 peripheral ========== */
#define TCC1_CC_NUM                              (4)        /* Number of Compare/Capture units */
#define TCC1_DITHERING                           (1)        /* Dithering feature implemented */
#define TCC1_DMAC_ID_OVF                         (29)       /* DMA overflow/underflow/retrigger trigger */
#define TCC1_DMAC_ID_MC0                         (30)       /* Indexes of DMA Match/Compare 0 trigger */
#define TCC1_DMAC_ID_MC1                         (31)       /* Indexes of DMA Match/Compare 1 trigger */
#define TCC1_DMAC_ID_MC2                         (32)       /* Indexes of DMA Match/Compare 2 trigger */
#define TCC1_DMAC_ID_MC3                         (33)       /* Indexes of DMA Match/Compare 3 trigger */
#define TCC1_DTI                                 (1)        /* Dead-Time-Insertion feature implemented */
#define TCC1_EXT                                 (31)       /* Coding of implemented extended features */
#define TCC1_GCLK_ID                             (25)       /* Index of Generic Clock */
#define TCC1_MASTER_SLAVE_MODE                   (2)        /* TCC type 0 : NA, 1 : Master, 2 : Slave */
#define TCC1_OTMX                                (1)        /* Output Matrix feature implemented */
#define TCC1_OW_NUM                              (8)        /* Number of Output Waveforms */
#define TCC1_PG                                  (1)        /* Pattern Generation feature implemented */
#define TCC1_SIZE                                (24)       
#define TCC1_SWAP                                (1)        /* DTI outputs swap feature implemented */
#define TCC1_INSTANCE_ID                         (44)       /* Instance index for TCC1 */

#endif /* _SAME51_TCC1_INSTANCE_ */
