
/**************   FICOSA COMMAND AND CONTROL SYSTEMS DIVISION  ****************
| File:              | TP_NetworkLayerLowerInterface_Rx.c
|-----------------------------------------------------------------------------
| Author:            | Author
|-----------------------------------------------------------------------------
| Project:           | Iso15765_2_Full
| System:            | Iso15765_2_Task_Full
| Diagram:           | TP_NetworkLayerLowerInterface_Rx
| Model Version:     | 1.0
| Model Date:        | Thursday, February 26, 2009 - 14:47:56
|-----------------------------------------------------------------------------
| CodeC Version:     | 1.0
| Codification Date: | 14/11/2011
|-----------------------------------------------------------------------------
| Description:
|    Codificacio automatica d'un diagrama d'estats
|
|    ++++ Informacio del Diagrama d'Estats +++++
|
|    Numero d'estats:       1
|    Numero de transicions: 0
|    Estats inicials:       0
|  
|    Variables d'entrada:
|    Variables de sortida:
|    Variables d'entrada/sortida:
|    Variables locals:
|
|    ++++ Descripcio del proces implementat ++++
|
|    Task responsible of notifying the CAN Frame Rx type 
to upper layers. 
|
**************************   FI DE LA CAPCALERA  ****************************/

/*------------------------------- includes --------------------------------*/
#include "Std_Types.h"
#include "DiagnosticR/Comp_HAL_Autosar_Wrappers/Timer.h"
#include "TP_Task.h"


#include "TP_Functions.h"

/*------------------------------ user code --------------------------------*/


/*-------------------------------- macros ---------------------------------*/





/*------------------------------ variables --------------------------------*/



/*------------------------------ funcions ---------------------------------*/
void TP_NetworkLayerLowerInterface_RxInicialitza(UI_8 tp_hdl)
{
    /* -- no hi ha inicialitzacio a les funcions simples -- */
}

/****************************************************************************
| Nom de la funcio: TP_NetworkLayerLowerInterface_Rx
|----------------------------------------------------------------------------
| Funcionalitat:                                              
|   Diagrama d'un sol estat d'un model Edi.
|----------------------------------------------------------------------------
| Interficie:                                                
|   Entrades: 
|   Sortides: 
 ****************************************************************************/
void TP_NetworkLayerLowerInterface_Rx(UI_8 tp_hdl)
{
    t_flag_value received_frame = 0;
    
    /* Check that the RX notif routine has been configured */
    if (TPCheckPhyCfgData(tp_hdl) == TRUE) {
        /* Get the RX flag from OsekCom */
       received_frame = ReadFlagRxSig(tp_data[tp_hdl].can_phy.sig_np_rx);

	 if(received_frame == 0)
	 {

	 }
	 else
	 {
		
	 }
	
	
        /* Case a new frame has been received */
        if (received_frame == COM_TRUE) {
            TPProcessRxCanPhyFrame(tp_hdl);
        }
        else {
            /* Do nothing */
        }
    }
    else {
        /* Do nothing */
    }

} /* TP_NetworkLayerLowerInterface_Rx */


/********************************** FI **************************************/
