
/**************   FICOSA COMMAND AND CONTROL SYSTEMS DIVISION  ****************
| File:              | TP_RxFun.c
|-----------------------------------------------------------------------------
| Author:            | Author
|-----------------------------------------------------------------------------
| Project:           | TP_Full
| System:            | TP_Task_Full
| Diagram:           | TP_RxFun
| Model Version:     | 1.0
| Model Date:        | Thursday, February 26, 2009 - 14:47:56
|-----------------------------------------------------------------------------
| CodeC Version:     | 1.0
| Codification Date: | 28/2/2011
|-----------------------------------------------------------------------------
| Description:
|    Codificacio automatica d'un diagrama d'estats
|
|    ++++ Informacio del Diagrama d'Estats +++++
|
|    Numero d'estats:       1
|    Numero de transicions: 0
|    Estats inicials:       0
|  
|    Variables d'entrada:
|    Variables de sortida:
|    Variables d'entrada/sortida:
|    Variables locals:
|
|    ++++ Descripcio del proces implementat ++++
|
|    
|
**************************   FI DE LA CAPCALERA  ****************************/

/*------------------------------- includes --------------------------------*/
#include "Std_Types.h"
#include "DiagnosticR/Comp_HAL_Autosar_Wrappers/Timer.h"
#include "TP_Task.h"


/*------------------------------ user code --------------------------------*/

#include "DiagnosticR/UDS/Iso15765_layer2/TP_CFG.h"
#include "TP_Functions.h"

/*-------------------------------- macros ---------------------------------*/





/*------------------------------ variables --------------------------------*/



/*------------------------------ funcions ---------------------------------*/
void TP_RxFunInicialitza(UI_8 tp_hdl)
{
    /* -- no hi ha inicialitzacio a les funcions simples -- */
}

/****************************************************************************
| Nom de la funcio: TP_RxFun
|----------------------------------------------------------------------------
| Funcionalitat:                                              
|   Diagrama d'un sol estat d'un model Edi.
|----------------------------------------------------------------------------
| Interficie:                                                
|   Entrades: 
|   Sortides: 
 ****************************************************************************/
void TP_RxFun(UI_8 tp_hdl)
{
    t_flag_value received_frame;
        
    /* Check that the functional RX notif routine has been configured */
    if(TPCheckFunCfgData(tp_hdl) == TRUE) {
        /* Get the RX flag from OsekCom */
        received_frame = ReadFlagRxSig(tp_data[tp_hdl].can_fun.sig_np_rx);
        if (received_frame == COM_TRUE) {
            TPReadFunFrm(tp_hdl);
        }
        else {
            /* Do nothing */
        }
    }
    else {
        /* Do nothing */
    }

} /* TP_RxFun */


/********************************** FI **************************************/
