
/*************************   FICOSA INTERNATIONAL ****************************
| File:              | TP_Rx_Lite.c
|-----------------------------------------------------------------------------
| Author:            | Abel Casas
|-----------------------------------------------------------------------------
| Project:           | TP_Lite
| System:            | TP_Task_Lite
| Diagram:           | TP_Rx_Lite
| Model Version:     | 1.0
| Model Date:        | Thursday, February 26, 2009 - 14:47:56
|-----------------------------------------------------------------------------
| CodeC Version:     | 1.0
| Codification Date: | 10/1/2012
|-----------------------------------------------------------------------------
| Description:
|    Codificacio automatica d'un diagrama d'estats
|
|    ++++ Informacio del Diagrama d'Estats +++++
|
|    Numero d'estats:       1
|    Numero de transicions: 0
|    Estats inicials:       0
|  
|    Variables d'entrada:
|    Variables de sortida:
|           tp_frm (t_tp_frm)
|    Variables d'entrada/sortida:
|    Variables locals:
|
|    ++++ Descripcio del proces implementat ++++
|
|    Task responsible of controlling all the flow of a reception of
a transport protocol frame. This task is responsible of checking
the correct reception of SF and sending the FC
when is needed according to the configuration of the 
ISO15765_2. Finally this task will notify to the application when
a new complete RX frame is available.
|
**************************   FI DE LA CAPCALERA  ****************************/

/*------------------------------- includes --------------------------------*/
#include "Std_Types.h"
#include "DiagnosticR/Comp_HAL_Autosar_Wrappers/Timer.h"
#include "TP_Task_Lite.h"

#include "DiagnosticR/UDS/Iso15765_layer2/TP_CFG.h"
#include "TP_Functions.h"
#include "TP.h"

/*-------------------------------- defines ---------------------------------*/



/*------------------------------ variables --------------------------------*/



/*------------------------------ user code --------------------------------*/


/*------------------------------ functions ---------------------------------*/
void TP_Rx_LiteInicialitza(UI_8 tp_hdl)
{
    /* -- no hi ha inicialitzacio a les funcions simples -- */
}

/****************************************************************************
| Nom de la funcio: TP_Rx_Lite
|----------------------------------------------------------------------------
| Funcionalitat:                                              
|   Diagrama d'un sol estat d'un model Edi.
|----------------------------------------------------------------------------
| Interficie:                                                
|   Entrades: 
|   Sortides: tp_frm 
 ****************************************************************************/
void TP_Rx_Lite(UI_8 tp_hdl)
{
    /* Check if a new SF has been received */
    if ((tp_data[tp_hdl].rx_st.frame_rx_type == TP_RX_SF) && 
        ((tp_frm[tp_hdl].sts_rx == TP_FRM_RX_IDLE) || (tp_frm[tp_hdl].sts_rx == TP_FRM_RX_ERR_NOTIF)) &&
        (tp_frm[tp_hdl].iso15765_2_block_rx == FALSE)) {
        TPReadSF(tp_hdl);
    }
    else {
        /* Reset the frame reception type */
        tp_data[tp_hdl].rx_st.frame_rx_type = TP_RX_NO_FRM;
    }

} /* TP_Rx_Lite */


/********************************** FI **************************************/
