/***************  COPYRIGHT (c) 2002-2007 FICOSA INTERNATIONAL   **************
| Language:       |  MISRA C
| Controller:     |  Generic
| Spec. Document: |  ISO15765-2-E.pdf
|-----------------|------------------------------------------------------------
| Project:        |  ISO15765-2
| Reference:      |  
|------------------------------------------------------------------------------
|    Date  - Cod. - Rev. - App. -             Description
| 12/09/02   AM                 Implementation of the kwp2000 for PSA.
| 19/08/04   DT                 Split ISO15765_2 protocol from the KWP2000
|                               because they are different modules.
| 24/04/09   DC                 Modification to guarantee the requirements SR1431, 
|                               SR1438, SR1681.
| 15/12/10   AC                 Converted ISO15765_2 protocol to multi-instance.
| 13/11/11   AC                 Converted ISO15765_2 to full-duplex
| 09/01/12   AC                 Changed file, routines and variable naming to 
|                               make it a standard component improving his
|                               comprehension and having a similar naming style 
|                               with MPDT.
|------------------------------------------------------------------------------
| DESCRIPTION:
|   User interface for the transport protocol ISO15765_2 on CAN.
|   ISO15765_2 protocol is a transport protocol that permits the sending and
|   reception of frames until 4096 bytes on a network protocol with frames of
|   lower size. The original frame is segemented and sent with flow control
|   data that allows to the reception node to mount again the original frame.
| GENERAL CONSIDERATIONS
|   - This implementation allows full duplex communications.
|   - This implementation allows for each instance a communication channel
|     with physical address in which both transmission and receptions could
|     be done and a funcional address for only receptions.
|   - The functional address channel only supports frames with less than
|     8 bytes of data.
|   - This header must be included by the application as it contains the
|     definitions of the tasks to send and receive transport protocol frames.
******************************************************************************/
#ifndef _TP_TASK_H
#define _TP_TASK_H

/*----------------------------- INCLUDES ---------------------------------*/

#include "DiagnosticR/UDS/Iso15765_layer2/TP_CFG.h"

#ifdef TP_MODE_FULL
  #include "TP_Task_Full.h"
#else
  #include "TP_Task_Lite.h"
#endif

/*----------------------------- DEFINES ----------------------------------*/

/*-------------------------- DATA TYEPS ----------------------------------*/

/*--------------------------- GLOBAL VARIABLES ---------------------------*/

/*--------------------------- ROUTINE PROTOTYPES ------------------------*/

/********************************** FI **************************************/

#endif
